//###########################################################################
//					tHƑw{eBNXwȁ@{bǧK
//###########################################################################
//@{bǧKރLbg"NoribMp"e֐vO
//							2010/05/28	toadmaru@fuRo	
//							2010/06/01	h.yamato		motor funcs. added
//###########################################################################
#include "DSP28x_Project.h"
#include "NolibM.h"

/***************************************************/
/*	Eݒp֐							   */	
/***************************************************/
void initNolibM(void)
{
	InitSysCtrl();		// VXeRg[WX^iDSP2803x_SysCtrl.cj
	DeviceInit();		// F2803x foCXiDevInit_F2803x.cj
	InitCpuTimers();	// CPU timer iDSP2803x_CpuTimers.cj
	InitAdc();  // ADRo[^(DSP2803x_Adc.c)
	
	ConfigCpuTimer(&CpuTimer0, 60, 500000);
	ConfigCpuTimer(&CpuTimer1, 60, 50000);
	ConfigCpuTimer(&CpuTimer2, 60, 1000); //1[ms]waitp: CPU^C}[ݒiCPU^C}[QCCPUFreq=60MHzC1000[us]j
	CpuTimer0Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0
	CpuTimer1Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0 
	CpuTimer2Regs.TCR.all = 0x4001;	// Use write-only instruction to set TSS bit = 0
	
	// ŏɃXs[J[特oȂ悤PWM0Zbg
	ePWM[3]->TBPRD = 0;//ePWM[4]->TBPRD = ePWM[5]->TBPRD = ePWM[6]->TBPRD = 0;
	
	// ŏɃ[^Ȃ悤ɃZbg
	motor( 0,MotCN3);
	motor( 0,MotCN4);
	
	EALLOW; // below registers are "protected", allow access.
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 1;  // Start ePWM timer
	EDIS;	// Disable register access
	
	EALLOW; // ADRo[^p4ch̃WX^ݒ
	AdcRegs.ADCSOC0CTL.bit.CHSEL 	= 0;	//SOC0A0(CN5)ɐݒCʂAdcResult.ADCRESULT0ɏo
	AdcRegs.ADCSOC1CTL.bit.CHSEL 	= 1;	//SOC1A1(CN6)ɐݒCʂAdcResult.ADCRESULT1ɏo
	AdcRegs.ADCSOC2CTL.bit.CHSEL 	= 2;	//SOC2A2(CN7)ɐݒCʂAdcResult.ADCRESULT2ɏo
	AdcRegs.ADCSOC3CTL.bit.CHSEL 	= 3;	//SOC3A3(CN10)ɐݒCʂAdcResult.ADCRESULT3ɏo
	
	AdcRegs.ADCSOC0CTL.bit.TRIGSEL 	= 5;	//set SOC0 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	AdcRegs.ADCSOC1CTL.bit.TRIGSEL 	= 5;	//set SOC1 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	AdcRegs.ADCSOC2CTL.bit.TRIGSEL 	= 5;	//set SOC0 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	AdcRegs.ADCSOC3CTL.bit.TRIGSEL 	= 5;	//set SOC1 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1

	AdcRegs.ADCSOC0CTL.bit.ACQPS 	= 6;	//set SOC0 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	AdcRegs.ADCSOC1CTL.bit.ACQPS 	= 6;	//set SOC1 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	AdcRegs.ADCSOC2CTL.bit.ACQPS 	= 6;	//set SOC2 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	AdcRegs.ADCSOC3CTL.bit.ACQPS 	= 6;	//set SOC3 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	EDIS;
		
}
/***************************************************/
/*	ADRo[^p֐								   */
/*	̓`l̓d0-4095̒lŕԂ@@@@@@@@@@@@@@@*/	
/***************************************************/
Uint16 sensor(Uint16 ch)
{
	Uint16 Voltage;	

	if(ch==CN5){
		AdcRegs.ADCSOCFRC1.bit.SOC0 = 1;
   		Voltage = AdcResult.ADCRESULT0;
	}
	else if(ch==CN6){
   		AdcRegs.ADCSOCFRC1.bit.SOC1 = 1;
  		Voltage = AdcResult.ADCRESULT1;
	}
	else if(ch==CN7){
   		AdcRegs.ADCSOCFRC1.bit.SOC2 = 1;
   		Voltage = AdcResult.ADCRESULT2;
	}
	else if(ch==CN10){
   		AdcRegs.ADCSOCFRC1.bit.SOC3 = 1;
   		Voltage = AdcResult.ADCRESULT3;
	}
	else{
		Voltage = 0; // ch͊ԈႢ̍ۂ0Ԃ
	}

	return Voltage;
	   		
}

/***************************************************/
/*	DC[^p֐F CW/CCW/BRAKE/FREE ̐ݒ			   */	
/***************************************************/
void setMotDir(Uint16 mode, Uint16 ch)
{
	if(ch==MotCN3){	// for U1/CN3 DC Motor
		if(mode==0){// Brake mode
			GpioDataRegs.GPASET.bit.GPIO8   =1;
			GpioDataRegs.GPASET.bit.GPIO10  =1;
		}
		if(mode==1){// CW(or CCW) mode
			GpioDataRegs.GPASET.bit.GPIO8   =1;
			GpioDataRegs.GPACLEAR.bit.GPIO10=1;
		}
		if(mode==2){// CCW(or CW) mode
			GpioDataRegs.GPACLEAR.bit.GPIO8 =1;
			GpioDataRegs.GPASET.bit.GPIO10  =1;
		}
		if(mode==3){// free mode
			GpioDataRegs.GPACLEAR.bit.GPIO8 =1;
			GpioDataRegs.GPACLEAR.bit.GPIO10=1;
		}
	}
	if(ch==MotCN4){	// for U1/CN4 DC Motor
		if(mode==0){// Brake mode
			GpioDataRegs.GPASET.bit.GPIO24  =1;
			GpioDataRegs.GPBSET.bit.GPIO34  =1;	
		}
		if(mode==1){// CW(or CCW) mode
			GpioDataRegs.GPASET.bit.GPIO24  =1;
			GpioDataRegs.GPBCLEAR.bit.GPIO34=1;	
		}
		if(mode==2){// CCW(or CW) mode
			GpioDataRegs.GPACLEAR.bit.GPIO24=1;
			GpioDataRegs.GPBSET.bit.GPIO34  =1;	
		}
		if(mode==3){// free mode
			GpioDataRegs.GPACLEAR.bit.GPIO24=1;
			GpioDataRegs.GPBCLEAR.bit.GPIO34=1;	
		}
	}
}
/***************************************************/
/*	DC[^p֐F PWM Duty@̐ݒ					   */	
/***************************************************/
void setMotSpd(Uint16 comp, Uint16 ch)
{
	if(comp> 100){comp=100;}
	ePWM[ch]->TBPRD = 150;
	ePWM[ch]->CMPA.half.CMPA = comp;
}
/***************************************************/
/*	DC[^p֐									   */	
/***************************************************/
void motor(int16 speed, Uint16 ch)
{	
	if(speed==0)		{setMotDir(0,ch); setMotSpd(0,ch);}
	if(speed>0)			{setMotDir(1,ch); setMotSpd(+speed,ch);}
	if(speed<0)			{setMotDir(2,ch); setMotSpd(-speed,ch);}
	if(speed==MotFree)	{setMotDir(3,ch); setMotSpd(0,ch);}
}
/***************************************************/
/*	T[{[^p֐ val:[-100 100]->comp:[1150 4550] */	
/***************************************************/
void servo(int16 val, Uint16 ch)
{
	Uint16 comp = (Uint16)(val*17+2850);
	if(comp>4550){comp=4550;}
	if(comp<1150){comp=1150;}
	
	ch=6;	// servo motor: available at CN16(ePWM6B) only
	ePWM[ch]->TBPRD = 37800;
	ePWM[ch]->CMPB = comp;
}
/***************************************************/
/*	I/O{[hSW1p֐								   */	
/***************************************************/
unsigned char sw1(unsigned char i)
{
	if(i == GpioDataRegs.GPADAT.bit.GPIO31)
		return(1);
	else
		return(0);	
}

/***************************************************/
/*	LEDŊ֐									   */	
/***************************************************/
void ledFlash(unsigned char command, Uint16 ch)
{
	if(command==TOGGLE)
	{
		switch(ch)
		{
			case 1:
				GpioDataRegs.GPATOGGLE.bit.GPIO1 = 1;
				break;
			case 2:
				GpioDataRegs.GPATOGGLE.bit.GPIO3 = 1;
				break;
			case 3:
				GpioDataRegs.GPBTOGGLE.bit.GPIO41 = 1;
				break;
			case 4:
				GpioDataRegs.GPBTOGGLE.bit.GPIO40 = 1;
				break;
			default:
				break;
		}
	}
	else
	{
		switch(ch)
		{
			case 1:
				GpioDataRegs.GPADAT.bit.GPIO1 = !command;
				break;
			case 2:
				GpioDataRegs.GPADAT.bit.GPIO3 = !command;
				break;
			case 3:
				GpioDataRegs.GPBDAT.bit.GPIO41 = !command;
				break;
			case 4:
				GpioDataRegs.GPBDAT.bit.GPIO40 = !command;
				break;
			default:
				break;
		}
	}
}

/***************************************************/
/*	P[ms]EFCg֐								   */
/***************************************************/
void wait(Uint16 ms)
{
	Uint16 i;
	for(i=0;i<ms;i++){
		CpuTimer2Regs.TCR.bit.TIF = 1;
		while(CpuTimer2Regs.TCR.bit.TIF != 1);
	}
}

/***************************************************/
/*	Xs[J[p֐P								   */	
/***************************************************/
void beep2(Uint16 f, Uint16 ch)
{
	ePWM[ch]->TBPRD = f;
	ePWM[ch]->CMPB = f / 2;
}

/***************************************************/
/*	Xs[J[p֐QiԎw肠j					   */	
/***************************************************/
void beep(Uint16 f, Uint16 ch, Uint16 ms)
{
	beep2(f, ch);
	wait(ms);
	beep2(0, ch);
}

/***************************************************/
/*	Xs[J[p֐QiԎw肠j					   */	
/***************************************************/
void mario(void)
{
	unsigned int part = 1;
	unsigned int cnt = 1;
	
	CpuTimer0Regs.PRD.all =  100000;
	CpuTimer0Regs.TCR.bit.TIF = 1;
	while(part <= 2){
		if(CpuTimer0Regs.TCR.bit.TIF == 1){
			CpuTimer0Regs.TCR.bit.TIF = 1;
				switch(part){
					case 1:
						if(400 < cnt && cnt < 450){
							beep2(SHI, 3);
						//	beep2(SO, 4);
						}else if(500 < cnt && cnt < 650){
							beep2((FA / 2), 3);
						//	beep2((RE / 2), 4);
						}else if(700 < cnt && cnt < 750){
							beep2((FA / 2), 3);
						//	beep2((RE / 2), 4);
						}else if(800 < cnt && cnt < 883){
							beep2((FA / 2), 3);
						//	beep2((RE / 2), 4);
						}else if(933 < cnt && cnt < 1016){
							beep2((MI / 2), 3);
						//	beep2((DO / 2), 4);
						}else if(1066 < cnt && cnt < 1150){
							beep2((RE / 2), 3);
						//	beep2(SHI, 4);
						}else if(1200 < cnt && cnt < 1550){
							beep2((DO / 2), 3);
						//	beep2(SO, 4);
						}else{
							beep2(0, 3);
						//	beep2(0, 4);
						}
				/*		if(400 < cnt && cnt < 450)
							beep2((MI / 2), 5);
						else if(500 < cnt && cnt < 650)
							beep2((MI / 2), 5);
						else if(700 < cnt && cnt < 750)
							beep2((MI / 2), 5);
						else if(800 < cnt && cnt < 883)
							beep2((MI / 2), 5);
						else if(933 < cnt && cnt < 1016)
							beep2((FA / 2), 5);
						else if(1066 < cnt && cnt < 1150)
							beep2((SO / 2), 5);
						else if(1200 < cnt && cnt < 1250)
							beep2((RA / 2), 5);
						else if(1300 < cnt && cnt < 1450)
							beep2((MI / 2), 5);
						else if(1500 < cnt && cnt < 1550)
							beep2((MI / 2), 5);
						else
							beep2(0, 5);
						break;
					case 2:
						if(cnt < 350)
//							beep2(RA, 5);
							beep2(0, 5);
						else
							beep2(0, 5);
						break;
				*/
				}
				cnt++;
				if(cnt == 1600){
				cnt = 1;
				part++;
			}
		}
	}
}


